summaryrefslogtreecommitdiffstats
path: root/ot-recorder
diff options
context:
space:
mode:
author Eric Hameleers <alien@slackware.com>2016-08-29 21:49:00 +0000
committer Eric Hameleers <alien@slackware.com>2016-08-29 21:49:00 +0000
commit850199f460cddc4549a1af75144cf0e9da0a6895 (patch)
treeaded46d4563d14275653fa43f5187cec636d938e /ot-recorder
parentbaf6da866fd82120bd8489173eb799c10b512d7b (diff)
downloadasb-850199f460cddc4549a1af75144cf0e9da0a6895.tar.gz
asb-850199f460cddc4549a1af75144cf0e9da0a6895.tar.xz
Initial revision
Diffstat (limited to 'ot-recorder')
-rwxr-xr-xot-recorder/build/ot-recorder.SlackBuild290
-rw-r--r--ot-recorder/build/slack-desc19
-rw-r--r--ot-recorder/build/slack-required4
3 files changed, 313 insertions, 0 deletions
diff --git a/ot-recorder/build/ot-recorder.SlackBuild b/ot-recorder/build/ot-recorder.SlackBuild
new file mode 100755
index 00000000..92a5ab5e
--- /dev/null
+++ b/ot-recorder/build/ot-recorder.SlackBuild
@@ -0,0 +1,290 @@
+#!/bin/sh
+# $Id$
+# Copyright 2016 Eric Hameleers, Eindhoven NL
+# All rights reserved.
+#
+# Permission to use, copy, modify, and distribute this software for
+# any purpose with or without fee is hereby granted, provided that
+# the above copyright notice and this permission notice appear in all
+# copies.
+#
+# THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
+# USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+# -----------------------------------------------------------------------------
+#
+# Slackware SlackBuild script
+# ===========================
+# By: Eric Hameleers <alien@slackware.com>
+# For: ot-recorder
+# Descr: OwnTracks recorder
+# URL: http://owntracks.org/
+# Build needs:
+# Needs: c-ares,libconfig,lua,mosquitto
+# Changelog:
+# 0.6.7-1: 29/Aug/2016 by Eric Hameleers <alien@slackware.com>
+# * Initial build.
+#
+# Run 'sh ot-recorder.SlackBuild' to build a Slackware package.
+# The package (.t?z) and .txt file as well as build logs are created in /tmp .
+# Install the package using 'installpkg' or 'upgradepkg --install-new'.
+#
+# -----------------------------------------------------------------------------
+
+PRGNAM=ot-recorder
+SRCNAM=recorder
+VERSION=${VERSION:-0.6.7}
+BUILD=${BUILD:-1}
+NUMJOBS=${NUMJOBS:-" -j4 "}
+TAG=${TAG:-alien}
+
+DOCS="Changelog LICENSE README.md"
+
+# Needed for the creation of the 'mosquitto' user account which we also
+# use in the mosquitto package (ot-recorder talks to this MQTT server):
+MOSQUSR=mosquitto
+MOSQUSRID=309
+MOSQGRP=mosquitto
+MOSQGRPID=309
+
+
+# Where do we look for sources?
+SRCDIR=$(cd $(dirname $0); pwd)
+
+# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
+TMP=${TMP:-/tmp/build}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+SOURCE="$SRCDIR/${SRCNAM}-${VERSION}.tar.gz"
+SRCURL="https://github.com/owntracks/${SRCNAM}/archive/${VERSION}.tar.gz"
+
+##
+## --- with a little luck, you won't have to edit below this point --- ##
+##
+
+# You can use your own private machine.conf file to overrule machine defaults:
+if [ -e $SRCDIR/machine.conf ]; then
+ . $SRCDIR/machine.conf
+elif [ -e /etc/slackbuild/machine.conf ]; then
+ . /etc/slackbuild/machine.conf
+else
+ # Automatically determine the architecture we're building on:
+ if [ -z "$ARCH" ]; then
+ case "$(uname -m)" in
+ i?86) ARCH=i486 ;;
+ arm*) readelf /usr/bin/file -A | egrep -q "Tag_CPU.*[4,5]" && ARCH=arm || ARCH=armv7hl ;;
+ # Unless $ARCH is already set, use uname -m for all other archs:
+ *) ARCH=$(uname -m) ;;
+ esac
+ export ARCH
+ fi
+ # Set CFLAGS/CXXFLAGS and LIBDIRSUFFIX:
+ case "$ARCH" in
+ i486) SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ x86_64) SLKCFLAGS="-O2 -fPIC"
+ SLKLDFLAGS="-L/usr/lib64"; LIBDIRSUFFIX="64"
+ ;;
+ armv7hl) SLKCFLAGS="-O2 -march=armv7-a -mfpu=vfpv3-d16"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ armv6hl) SLKCFLAGS="-O2 -march=armv6 -mfpu=vfp -mfloat-abi=hard"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ armv5hl) SLKCFLAGS="-O2 -mthumb -march=armv5te -mtune=arm1176jzf-s -mfpu=vfp -mfloat-abi=softfp"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ *) SLKCFLAGS=${SLKCFLAGS:-"O2"}
+ SLKLDFLAGS=${SLKLDFLAGS:-""}; LIBDIRSUFFIX=${LIBDIRSUFFIX:-""}
+ ;;
+ esac
+fi
+
+case "$ARCH" in
+ arm*) TARGET=$ARCH-slackware-linux-gnueabi ;;
+ *) TARGET=$ARCH-slackware-linux ;;
+esac
+
+# Exit the script on errors:
+set -e
+trap 'echo "$0 FAILED at line ${LINENO}" | tee $OUTPUT/error-${PRGNAM}.log' ERR
+# Catch unitialized variables:
+set -u
+P1=${1:-1}
+
+# Save old umask and set to 0022:
+_UMASK_=$(umask)
+umask 0022
+
+# Create working directories:
+mkdir -p $OUTPUT # place for the package to be saved
+mkdir -p $TMP/tmp-$PRGNAM # location to build the source
+mkdir -p $PKG # place for the package to be built
+rm -rf $PKG/* # always erase old package's contents
+rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
+rm -rf $OUTPUT/{checkout,configure,make,install,error,makepkg,patch}-$PRGNAM.log
+ # remove old log files
+
+# Source file availability:
+if ! [ -f ${SOURCE} ]; then
+ echo "Source '$(basename ${SOURCE})' not available yet..."
+ # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
+ [ -w "$SRCDIR" ] || SOURCE="$OUTPUT/$(basename $SOURCE)"
+ if [ -f ${SOURCE} ]; then echo "Ah, found it!"; continue; fi
+ if ! [ "x${SRCURL}" == "x" ]; then
+ echo "Will download file to $(dirname $SOURCE)"
+ wget --content-disposition -nv -T 20 -O "${SOURCE}" "${SRCURL}" || true
+ if [ $? -ne 0 -o ! -s "${SOURCE}" ]; then
+ echo "Downloading '$(basename ${SOURCE})' failed... aborting the build."
+ mv -f "${SOURCE}" "${SOURCE}".FAIL
+ exit 1
+ fi
+ else
+ echo "File '$(basename ${SOURCE})' not available... aborting the build."
+ exit 1
+ fi
+fi
+
+if [ "$P1" == "--download" ]; then
+ echo "Download complete."
+ exit 0
+fi
+
+# --- PACKAGE BUILDING ---
+
+echo "++"
+echo "|| $PRGNAM-$VERSION"
+echo "++"
+
+cd $TMP/tmp-$PRGNAM
+echo "Extracting the source archive(s) for $PRGNAM..."
+tar -xvf ${SOURCE}
+cd ${SRCNAM}-${VERSION}
+chown -R root:root .
+chmod -R u+w,go+r-w,a+rX-st .
+
+echo Building ...
+export LDFLAGS="$SLKLDFLAGS"
+export CXXFLAGS="$SLKCFLAGS"
+export CFLAGS="$SLKCFLAGS"
+cp config.mk.in config.mk
+sed -i -e '/^CFLAGS/s/ -Werror//' Makefile
+make \
+ INSTALLDIR=/usr \
+ WITH_LUA=yes \
+ MOSQUITTO_LIB=-L/usr/lib${LIBDIRSUFFIX} \
+ CONFIGFILE=/etc/ot-recorder.conf \
+ 2>&1 | tee $OUTPUT/make-${PRGNAM}.log
+
+# Manual installation:
+mkdir -p $PKG/etc/default $PKG/etc/rc.d
+mkdir -p $PKG/usr/bin $PKG/usr/sbin
+mkdir -p $PKG/var/spool/owntracks/recorder/store/{ghash,last}
+mkdir -p $PKG/var/spool/owntracks/recorder/htdocs
+cp -R docroot/* $PKG/var/spool/owntracks/recorder/htdocs/
+install --mode 0755 ot-recorder $PKG/usr/sbin
+install --mode 0755 ocat $PKG/usr/bin
+cp etc/rhel/ot-recorder.defaults $PKG/etc/default/ot-recorder
+install --mode 0755 etc/rhel/ot-recorder.init $PKG/etc/rc.d/rc.ot-recorder.new
+
+# Add this to the doinst.sh:
+mkdir -p $PKG/install
+cat <<EOINS >> $PKG/install/doinst.sh
+# Handle the incoming configuration files:
+config() {
+ for infile in \$1; do
+ NEW="\$infile"
+ OLD="\`dirname \$NEW\`/\`basename \$NEW .new\`"
+ # If there's no config file by that name, mv it over:
+ if [ ! -r \$OLD ]; then
+ mv \$NEW \$OLD
+ elif [ "\`cat \$OLD | md5sum\`" = "\`cat \$NEW | md5sum\`" ]; then
+ # toss the redundant copy
+ rm \$NEW
+ fi
+ # Otherwise, we leave the .new copy for the admin to consider...
+ done
+}
+
+preserve_perms() {
+ NEW="\$1"
+ OLD="\$(dirname \$NEW)/\$(basename \$NEW .new)"
+ if [ -e \$OLD ]; then
+ cp -a \$OLD \${NEW}.incoming
+ cat \$NEW > \${NEW}.incoming
+ mv \${NEW}.incoming \$NEW
+ fi
+ config \$NEW
+}
+
+preserve_perms etc/rc.d/rc.ot-recorder.new
+
+# Only way to create and use the correct uid and gid on the target system,
+# is to use chroot:
+chroot . <<EOR 2>/dev/null
+# Add the '${MOSQGRP}' group if it doesn't already exist:
+/usr/sbin/groupadd -g ${MOSQGRPID} ${MOSQGRP} 2> /dev/null
+# Add the '${MOSQUSR}' user if it doesn't already exist:
+/usr/sbin/useradd -c "Mosquitto service account" \\
+ -u ${MOSQUSRID} -g ${MOSQGRP} -s "/bin/false" ${MOSQUSR} 2> /dev/null
+
+# Restore the correct permissions
+chown -R ${MOSQUSR}:${MOSQGRP} var/spool/owntracks/recorder/store
+
+# Binaries are setuid $MOSQUSR:
+chown ${MOSQUSR}:${MOSQGRP} usr/bin/ocat usr/sbin/ot-recorder
+chmod 4751 /usr/bin/ocat /usr/sbin/ot-recorder
+
+#Initialize the LMDB databases.
+# This initialization is non-destructive - it will not delete any data.
+ot-recorder --initialize
+
+EOR
+
+EOINS
+
+# Add documentation:
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
+cat $SRCDIR/$(basename $0) > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+chown -R root:root $PKG/usr/doc/$PRGNAM-$VERSION
+find $PKG/usr/doc -type f -exec chmod 644 {} \;
+
+# Compress the man page(s):
+if [ -d $PKG/usr/man ]; then
+ find $PKG/usr/man -type f -name "*.?" -exec gzip -9f {} \;
+ for i in $(find $PKG/usr/man -type l -name "*.?") ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+fi
+
+# Strip binaries (if any):
+find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+# Add a package description:
+mkdir -p $PKG/install
+cat $SRCDIR/slack-desc > $PKG/install/slack-desc
+cat $SRCDIR/slack-required > $PKG/install/slack-required
+
+# Build the package:
+cd $PKG
+makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz} 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
+cd $OUTPUT
+md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz} > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz}.md5
+cd -
+cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.txt
+cat $PKG/install/slack-required > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.dep
+
+# Restore the original umask:
+umask ${_UMASK_}
+
diff --git a/ot-recorder/build/slack-desc b/ot-recorder/build/slack-desc
new file mode 100644
index 00000000..6a3ee3ee
--- /dev/null
+++ b/ot-recorder/build/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description. Line
+# up the first '|' above the ':' following the base package name, and the '|'
+# on the right side marks the last column you can put a character in. You must
+# make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+ot-recorder: ot-recorder (OwnTracks recorder)
+ot-recorder:
+ot-recorder: OwnTracks is a location-based service which runs over MQTT.
+ot-recorder: The OwnTracks Recorder connects to an MQTT broker and stores
+ot-recorder: location publishes from the OwnTracks apps (iOS, Android) into
+ot-recorder: files which can be viewed through the supporting ocat utility
+ot-recorder: and via a REST API provided by the Recorder itself.
+ot-recorder:
+ot-recorder:
+ot-recorder: ot-recorder home: http://owntracks.org/
+ot-recorder:
diff --git a/ot-recorder/build/slack-required b/ot-recorder/build/slack-required
new file mode 100644
index 00000000..e078ae7f
--- /dev/null
+++ b/ot-recorder/build/slack-required
@@ -0,0 +1,4 @@
+c-ares
+libconfig
+lua
+mosquitto